From 62ff78f20ed91a77e2ab2446e292776053562cd3 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 07:26:54 +0000
Subject: [PATCH 1268/2232] Move dependency-collecting logic to module


---

diff --git a/gen/build/src/deps.rs b/gen/build/src/deps.rs
new file mode 100644
index 0000000..05a15d3
--- /dev/null
+++ b/gen/build/src/deps.rs
@@ -0,0 +1,38 @@
+use std::collections::BTreeMap;
+use std::env;
+use std::path::PathBuf;
+
+pub fn include_dirs() -> impl Iterator<Item = PathBuf> {
+    let mut env_include_dirs = BTreeMap::new();
+    for (k, v) in env::vars_os() {
+        let mut k = k.to_string_lossy().into_owned();
+        // Only variables set from a build script of direct dependencies are
+        // observable. That's exactly what we want! Your crate needs to declare
+        // a direct dependency on the other crate in order to be able to
+        // #include its headers.
+        //
+        // Also, they're only observable if the dependency's manifest contains a
+        // `links` key. This is important because Cargo imposes no ordering on
+        // the execution of build scripts without a `links` key. When exposing a
+        // generated header for the current crate to #include, we need to be
+        // sure the dependency's build script has already executed and emitted
+        // that generated header.
+        //
+        // References:
+        //   - https://doc.rust-lang.org/cargo/reference/build-scripts.html#the-links-manifest-key
+        //   - https://doc.rust-lang.org/cargo/reference/build-script-examples.html#using-another-sys-crate
+        if k.starts_with("DEP_") {
+            if k.ends_with("_CXXBRIDGE_INCLUDE") {
+                // Tweak to ensure sorted before the other one, for the same
+                // reason as the comment on ordering of include_dir vs crate_dir
+                // above.
+                k.replace_range(k.len() - "INCLUDE".len().., "0");
+                env_include_dirs.insert(k, PathBuf::from(v));
+            } else if k.ends_with("_CXXBRIDGE_CRATE") {
+                k.replace_range(k.len() - "CRATE".len().., "1");
+                env_include_dirs.insert(k, PathBuf::from(v));
+            }
+        }
+    }
+    env_include_dirs.into_iter().map(|entry| entry.1)
+}
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index ef34d43..6908f3c 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -55,6 +55,7 @@
 )]
 
 mod cfg;
+mod deps;
 mod error;
 mod gen;
 mod intern;
@@ -70,7 +71,6 @@ use crate::gen::Opt;
 use crate::paths::PathExt;
 use crate::target::TargetDir;
 use cc::Build;
-use std::collections::BTreeMap;
 use std::env;
 use std::ffi::{OsStr, OsString};
 use std::io::{self, Write};
@@ -199,48 +199,13 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
         build.include(crate_dir);
         eprintln!("  {}", crate_dir.display());
     }
-    for dep in env_include_dirs() {
+    for dep in deps::include_dirs() {
         build.include(&dep);
         eprintln!("  {}", dep.display());
     }
     Ok(build)
 }
 
-fn env_include_dirs() -> impl Iterator<Item = PathBuf> {
-    let mut env_include_dirs = BTreeMap::new();
-    for (k, v) in env::vars_os() {
-        let mut k = k.to_string_lossy().into_owned();
-        // Only variables set from a build script of direct dependencies are
-        // observable. That's exactly what we want! Your crate needs to declare
-        // a direct dependency on the other crate in order to be able to
-        // #include its headers.
-        //
-        // Also, they're only observable if the dependency's manifest contains a
-        // `links` key. This is important because Cargo imposes no ordering on
-        // the execution of build scripts without a `links` key. When exposing a
-        // generated header for the current crate to #include, we need to be
-        // sure the dependency's build script has already executed and emitted
-        // that generated header.
-        //
-        // References:
-        //   - https://doc.rust-lang.org/cargo/reference/build-scripts.html#the-links-manifest-key
-        //   - https://doc.rust-lang.org/cargo/reference/build-script-examples.html#using-another-sys-crate
-        if k.starts_with("DEP_") {
-            if k.ends_with("_CXXBRIDGE_INCLUDE") {
-                // Tweak to ensure sorted before the other one, for the same
-                // reason as the comment on ordering of include_dir vs crate_dir
-                // above.
-                k.replace_range(k.len() - "INCLUDE".len().., "0");
-                env_include_dirs.insert(k, PathBuf::from(v));
-            } else if k.ends_with("_CXXBRIDGE_CRATE") {
-                k.replace_range(k.len() - "CRATE".len().., "1");
-                env_include_dirs.insert(k, PathBuf::from(v));
-            }
-        }
-    }
-    env_include_dirs.into_iter().map(|entry| entry.1)
-}
-
 fn make_crate_dir(prj: &Project) -> Option<PathBuf> {
     if prj.include_prefix.as_os_str().is_empty() {
         let crate_dir = prj.manifest_dir.clone();

